﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace eAnalyze.Common
{
    public class EditableRadCombo
    {
        public static readonly DependencyProperty EditableComboxMaxlengthProperty =
            DependencyProperty.RegisterAttached("MaxLength", typeof(int), typeof(EditableRadCombo), new PropertyMetadata(OnMaxLengthChanged));

        public static int GetMaxLength(DependencyObject obj)
        {
            return (int)obj.GetValue(EditableComboxMaxlengthProperty);
        }

        public static void SetMaxLength(DependencyObject obj, int value)
        {
            obj.SetValue(EditableComboxMaxlengthProperty, value);
        }

        private static void OnMaxLengthChanged(DependencyObject obj, DependencyPropertyChangedEventArgs e)
        {
            var comboBox = obj as Telerik.Windows.Controls.RadComboBox;
            if (comboBox == null)
                return;

            comboBox.Dispatcher.BeginInvoke(
                delegate()
                {
                    var rootElement = VisualTreeHelper.GetChild(comboBox, 0) as FrameworkElement;
                    TextBox textBox = (TextBox)rootElement.FindName("PART_EditableTextBox");
                    if (textBox != null)
                        textBox.SetValue(TextBox.MaxLengthProperty, e.NewValue);
                });

        }
    }

}
